//+------------------------------------------------------------------+
//|                                              TrendHistograms.mq4 |
//|                              Copyright  2014, Ranzato Flaminio. |
//+------------------------------------------------------------------+
#property copyright "Copyright  2014, Flaminio Ranzato."
#property link      "https://www.facebook.com/FlaminioRanzato"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 CLR_NONE
#property indicator_color2 Magenta
#property indicator_color3 DodgerBlue
#property indicator_width2 2
#property indicator_width3 2

extern int ADX_Period = 90;
extern int Smooth_Period = 3;

double b1[];
double b2[];
double b3[];

int init()  {
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(0,b1);
   SetIndexBuffer(1,b2);
   SetIndexBuffer(2,b3);
   return(0);
}
int start() {

   int counted_bars=IndicatorCounted();
   int i,limit;
   double Signal;
   
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   limit=Bars-1;
   if(counted_bars>=1) limit=Bars-counted_bars-1;
   if (limit<0) limit=0;
   
   for(i=0; i<limit; i++) {
      b1[i]=iADX(NULL,0,ADX_Period,PRICE_CLOSE,MODE_PLUSDI,i)-iADX(NULL,0,ADX_Period,PRICE_CLOSE,MODE_MINUSDI,i);
      }

   for (i=limit;i>=0;i--)   {
     
      b1[i]=iMAOnArray(b1,0,Smooth_Period,0,MODE_SMA,i);
          
      if (b1[i]<=0)
         b2[i]=b1[i];
      if (b1[i]>0)
         b3[i]=b1[i];

   }
   return(0);
}